/*
   FNT - SQL-backend for SQLite3 - function fetch_row

   Copyright (C) 2009 Free Software Foundation, Inc.

   Written by:
   Slava Zanko <slavazanko@gmail.com>


   This file is part of the FIDO New Technology.

   FIDO New Technology is free software: you can redistribute it and/or 
   modify it under the terms of the GNU General Public License as published 
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include <sqlite3.h>
#include <stdlib.h>

#include "../include/global.h"

#include "../include/types.h"
#include "../include/error.h"
#include "../include/plugin.h"
#include "../include/sql.h"

#include "main.h"

/*** global variables **************************************************/

/*** file scope macro definitions **************************************/

/*** file scope type declarations **************************************/

/*** file scope variables **********************************************/

/*** file scope functions **********************************************/

/*** public functions **************************************************/

DLLEXPORT fnt_sql_row_t *
fetch_row (fnt_sql_query_t * query)
{
    fnt_sql_row_t *sql_row;

    if (query == NULL)
	return NULL;


    if (query->__current_row != -1)
    {
	if (sqlite3_step ((sqlite3_stmt *) query->handle) != SQLITE_ROW)
	    return NULL;
    }

    query->__current_row++;

    sql_row = g_try_malloc (sizeof (fnt_sql_row_t));
    if (sql_row == NULL)
	return NULL;

    sql_row->query = query;
    sql_row->handle = NULL;

    return sql_row;
}
